state("bio4")
{
	byte currentArea    : 0x7FC1C9;
	byte currentScreen  : 0x8597BB;
	byte loadingScreen  : 0x858F77;
	byte loadingCount   : 0x858F7B;
	byte merchant       : 0x87AB47;
	int  isEndOfChapter : 0x85F6F8;
	int  mgEnd          : 0x8594B8;
	int  swEnd          : 0x867BDC;
	int  igt            : 0x85F704;
}

state("bio4", "1.0.6")
{
	byte currentArea    : 0x7FB1C9;
	byte currentScreen  : 0x855F3B;
	byte loadingScreen  : 0x8556F7;
	byte loadingCount   : 0x8556FB;
	byte merchant       : 0x8772C7;
	int  isEndOfChapter : 0x85BE78;
	int  mgEnd          : 0x855C38;
	int  swEnd          : 0x86434C;
	int  igt            : 0x85BE84;
}

startup
{
	settings.Add("MainGame", true, "Main Game");
	settings.Add("MainGameChapters", true, "Chapters", "MainGame");
	settings.Add("Area233", true, "Chapter 1-1", "MainGameChapters");
	settings.Add("Area192", true, "Chapter 1-2", "MainGameChapters");
	settings.Add("Area202", true, "Chapter 1-3", "MainGameChapters");
	settings.Add("Area138", true, "Chapter 2-1", "MainGameChapters");
	settings.Add("Area81", true, "Chapter 2-2", "MainGameChapters");
	settings.Add("Area111", true, "Chapter 2-3", "MainGameChapters");
	settings.Add("Area209", true, "Chapter 3-1", "MainGameChapters");
	settings.Add("Area149", true, "Chapter 3-2", "MainGameChapters");
	settings.Add("Area17", true, "Chapter 3-3", "MainGameChapters");
	settings.Add("Area174", true, "Chapter 3-4 / 4-1", "MainGameChapters");
	settings.Add("Area119", true, "Chapter 4-2", "MainGameChapters");
	settings.Add("Area167", true, "Chapter 4-3", "MainGameChapters");
	settings.Add("Area250", true, "Chapter 4-4", "MainGameChapters");
	settings.Add("Area74", true, "Chapter 5-1", "MainGameChapters");
	settings.Add("Area123", true, "Chapter 5-2", "MainGameChapters");
	settings.Add("Area140", true, "Chapter 5-3", "MainGameChapters");
	settings.Add("Area37", true, "Chapter 5-4", "MainGameChapters");
	settings.Add("Area183", true, "Final Chapter", "MainGameChapters");

	settings.Add("SeparateWays", true, "Separate Ways");
	settings.Add("SeparateWaysChapters", true, "Chapters", "SeparateWays");
	settings.Add("Area231", true, "Chapter 1", "SeparateWaysChapters");
	settings.Add("Area112", true, "Chapter 2", "SeparateWaysChapters");
	settings.Add("Area79", true, "Chapter 3", "SeparateWaysChapters");
	settings.Add("Area70", true, "Chapter 4", "SeparateWaysChapters");
	settings.Add("Area68", true, "Chapter 5", "SeparateWaysChapters");

	settings.Add("MerchantMode", false, "Merchant Mode");

	settings.SetToolTip("MainGameChapters", "Check this Option if you want to start on Beginning of Chapter.");
	settings.SetToolTip("SeparateWaysChapters", "Check this Option if you want to start on Beginning of Chapter.");
	settings.SetToolTip("MerchantMode", "Check this Option if you want to start on Merchant.");

	vars.BlackListedDoors = new Dictionary<int, Tuple<int, int>>{ };
	vars.WhiteListedDoors = new Dictionary<int, Tuple<int, int>>{ };
	vars.BlackListedDoors.Add(1, Tuple.Create(0, 0));
	vars.BlackListedDoors.Add(2, Tuple.Create(0, 0));

	vars.BlackListedDoors.Add(3, Tuple.Create(159, 192));
	vars.BlackListedDoors.Add(4, Tuple.Create(178, 138));
	vars.BlackListedDoors.Add(5, Tuple.Create(207, 174));
	vars.BlackListedDoors.Add(6, Tuple.Create(221, 174));
	vars.BlackListedDoors.Add(7, Tuple.Create(248, 88));
	vars.BlackListedDoors.Add(8, Tuple.Create(236, 2));
	vars.BlackListedDoors.Add(9, Tuple.Create(2, 119));
	vars.BlackListedDoors.Add(10, Tuple.Create(154, 167));
	vars.BlackListedDoors.Add(11, Tuple.Create(167, 250));
	vars.BlackListedDoors.Add(12, Tuple.Create(229, 74));
	vars.BlackListedDoors.Add(13, Tuple.Create(80, 140));
	vars.BlackListedDoors.Add(14, Tuple.Create(140, 113));
	vars.BlackListedDoors.Add(15, Tuple.Create(113, 140));
	vars.BlackListedDoors.Add(16, Tuple.Create(147, 37));

	vars.BlackListedDoors.Add(17, Tuple.Create(173, 112));
	vars.BlackListedDoors.Add(18, Tuple.Create(202, 79));
	vars.BlackListedDoors.Add(19, Tuple.Create(216, 70));
	vars.BlackListedDoors.Add(20, Tuple.Create(119, 68));

	vars.WhiteListedDoors.Add(1, Tuple.Create(7, 206));
	vars.WhiteListedDoors.Add(2, Tuple.Create(149, 7));
	vars.WhiteListedDoors.Add(3, Tuple.Create(133, 207));
	vars.WhiteListedDoors.Add(4, Tuple.Create(133, 237));
	vars.WhiteListedDoors.Add(5, Tuple.Create(221, 180));
	vars.WhiteListedDoors.Add(6, Tuple.Create(230, 178));
	vars.WhiteListedDoors.Add(7, Tuple.Create(150, 13));
	vars.WhiteListedDoors.Add(8, Tuple.Create(150, 88));
	vars.WhiteListedDoors.Add(9, Tuple.Create(183, 252));
	vars.WhiteListedDoors.Add(10, Tuple.Create(192, 68));
	vars.WhiteListedDoors.Add(11, Tuple.Create(192, 191));
	vars.WhiteListedDoors.Add(12, Tuple.Create(123, 216));
	vars.WhiteListedDoors.Add(13, Tuple.Create(216, 226));
	vars.WhiteListedDoors.Add(14, Tuple.Create(160, 141));
	vars.WhiteListedDoors.Add(15, Tuple.Create(101, 81));
	vars.WhiteListedDoors.Add(16, Tuple.Create(123, 191));

	vars.WhiteListedDoors.Add(17, Tuple.Create(112, 231));
	vars.WhiteListedDoors.Add(18, Tuple.Create(231, 160));
	vars.WhiteListedDoors.Add(19, Tuple.Create(160, 145));
	vars.WhiteListedDoors.Add(20, Tuple.Create(153, 34));
}

init
{
	version = modules.First().FileVersionInfo.FileVersion;
	version = version == "1.0.18384.3" || version == "1.0.18384.2" || version == "1.0.18384.1" ? "1.0.6" : "";

	vars.TimerModel = new TimerModel { CurrentState = timer };

	Action ResetVariables = () => {
		vars.BlackListedDoors[1] = Tuple.Create(0, 0);
		vars.BlackListedDoors[2] = Tuple.Create(0, 0);
	};
	vars.ResetVariables = ResetVariables;
	vars.ResetVariables();
}

start
{
	if (current.loadingCount <= 240 && old.loadingCount >= 240 && settings["Area" + current.currentArea.ToString()])
	{
		vars.ResetVariables();
		return true;
	}

	if (current.merchant == 248 && old.merchant == 0 && settings["MerchantMode"])
		return true;
}

split
{
	if (current.currentArea != old.currentArea)
	{
		if (!vars.BlackListedDoors.ContainsValue(Tuple.Create(Convert.ToInt32(old.currentArea), Convert.ToInt32(current.currentArea))))
		{
			vars.BlackListedDoors[1] = Tuple.Create(Convert.ToInt32(old.currentArea), Convert.ToInt32(current.currentArea));
			vars.BlackListedDoors[2] = Tuple.Create(Convert.ToInt32(current.currentArea), Convert.ToInt32(old.currentArea));
			return true;
		}
		if (vars.WhiteListedDoors.ContainsValue(Tuple.Create(Convert.ToInt32(old.currentArea), Convert.ToInt32(current.currentArea))) || vars.WhiteListedDoors.ContainsValue(Tuple.Create(Convert.ToInt32(current.currentArea), Convert.ToInt32(old.currentArea))))
		{
			return true;
		}
	}

	if (current.isEndOfChapter - old.isEndOfChapter == 65536)
		return true;

	if (current.currentArea == 174 && old.currentArea == 207 && current.isEndOfChapter >= 655360)
		return true;

	if (current.merchant == 0 && old.merchant == 248 && settings["MerchantMode"])
		return true;

	return current.mgEnd != old.mgEnd && current.currentArea == 97 || current.swEnd != old.swEnd && current.currentArea == 250;
}

isLoading
{
	if (current.currentArea == 65 || current.currentArea == 175 || current.currentArea == 64)
		return current.loadingScreen == 255 || current.loadingCount >= 240 || current.currentScreen == 208 || current.loadingCount >= 100 && current.currentScreen == 64;
	else if (current.currentArea == 192 || current.currentArea == 2 || current.currentArea == 148)
		return current.loadingScreen == 255 || current.loadingCount >= 240 || current.currentScreen == 208 || current.loadingCount >= 220 && current.currentScreen == 64;
	else
		return current.loadingScreen == 255 || current.loadingCount >= 240 || current.currentScreen == 208;
}

reset
{
	if (current.igt == 0 && old.igt != 0)
	{
		vars.ResetVariables();
		return true;
	}
}

exit
{
	if (timer.CurrentPhase != TimerPhase.Ended)
		vars.TimerModel.Reset();
}